/* wiring of the keypad:
if the keyboard lies before you so that you can read the numbers (the connector cable pointing towards you) with an arduino UNO:
pins from the left to the right:
  keypad - UNO
  1     -    2
  2     -    3
  3     -    4
  4     -    5
  5     -    6
  6     -    7
  7     -    8
  8     -    9 

Connect the I2C Pins of Arduino and Raspberry as follows:
 SDA (A4 on an UNO) to SCL (GPIO3, Pin 5) on the Raspi
 SCL (A5 on an UNO) to SDA (GPIO2, Pin 3) on the Raspi
 GND of Arduino to GND of Raspi
 see also http://blog.oscarliang.net/raspberry-pi-arduino-connected-i2c/

*/

#include <Wire.h>
#define SLAVE_ADDRESS 0x04
char cchar = 'G';
String resp = "";

byte h=0,v=0;    //variables used in for loops
const unsigned long period=50;  //little period used to prevent error
unsigned long kdelay=0;        // variable used in non-blocking delay 
const byte rows=4;             //number of rows of keypad
const byte columns=4;            //number of columnss of keypad
const byte Output[rows]={2,3,4,5}; //array of pins used as output for rows of keypad
const byte Input[columns]={6,7,8,9}; //array of pins used as input for columnss of keypad

int tuer = 10; //pin with relay for door
int count = 0;
int I2Ccommand;
char byteArray[4];
bool RequestCalled = false;

byte keypad() // function used to detect which button is used 
{
 static bool no_press_flag=0;  //static flag used to ensure no button is pressed 
  for(byte x=0;x<columns;x++)   // for loop used to read all inputs of keypad to ensure no button is pressed 
  {
     if (digitalRead(Input[x])==HIGH);   //read evry input if high continue else break;
     else
     break;
     if(x==(columns-1))   //if no button is pressed 
     {
      no_press_flag=1;
      h=0;
      v=0;
     }
  }
  if(no_press_flag==1) //if no button is pressed 
  {
    for(byte r=0;r<rows;r++) //for loop used to make all output as low
    digitalWrite(Output[r],LOW);
    for(h=0;h<columns;h++)  // for loop to check if one of inputs is low
    {
      if(digitalRead(Input[h])==HIGH) //if specific input is remain high (no press on it) continue
      continue;
      else    //if one of inputs is low
      {
          for (v=0;v<rows;v++)   //for loop used to specify the number of row
          {
          digitalWrite(Output[v],HIGH);   //make specified output as HIGH
          if(digitalRead(Input[h])==HIGH)  //if the input that selected from first sor loop is change to high
          {
            no_press_flag=0;                //reset the no press flag;
            for(byte w=0;w<rows;w++) // make all outputs as low
            digitalWrite(Output[w],LOW);
            return v*4+h;  //return number of button 
          }
          }
      }
    }
  }
 return 50;
}
void setup() 
{
  pinMode(13, OUTPUT);
  pinMode(tuer, OUTPUT);       
  Wire.begin(SLAVE_ADDRESS);
  Wire.onReceive(receiveData);
  Wire.onRequest(sendData);
  for(byte i=0;i<rows;i++)  //for loop used to make pin mode of outputs as output
  {
  pinMode(Output[i],OUTPUT);
  }
  for(byte s=0;s<columns;s++)  //for loop used to makk pin mode of inputs as inputpullup
  {
    pinMode(Input[s],INPUT_PULLUP);
  }
  digitalWrite(tuer,0); //start with relay open, so door is closed
}
void loop()
{
  if (RequestCalled) {
        RequestCalled=false;
    }
  if(millis()-kdelay>period) //used to make non-blocking delay
  {
      kdelay=millis();  //capture time from millis function
      switch (keypad())  //switch used to specify which button
    {
            case 0:
            cchar = 'D';
       break;  
            case 1:
            cchar = '#';
       break;
            case 2:
            cchar = '0';
       break;
            case 3:
            cchar = '*';
       break;
            case 4:
            cchar = 'C';
       break;
            case 5:
            cchar = '9';
       break;
            case 6:
            cchar = '8';
       break;
            case 7:
            cchar = '7';
       break;
            case 8:
            cchar = 'B';
       break;
            case 9:
            cchar = '6';
       break;
            case 10:
            cchar = '5';
       break;
            case 11:
            cchar = '4';
       break;
            case 12:
            cchar = 'A';
       break;
            case 13:
            cchar = '3';
       break;
            case 14:
            cchar = '2';
       break;
            case 15:
            cchar = '1';
       break;
            default:
            ;
    }
  }
}

// callback for sending data
void sendData(){
  if (cchar != 'G') {
    Wire.write(cchar);
    cchar = 'G';
  }
}

void receiveData(int byteCount)
{
 
  while(Wire.available())
  {
    // read I2C value
    I2Ccommand = Wire.read();
    if ( I2Ccommand >= 10 ) {  // do not switch pins where keyboard is connected to
      //Serial.println(I2Ccommand); 
      if (I2Ccommand == 10) {
        //Serial.println("ein");
        digitalWrite(tuer,1);
      } else if (I2Ccommand == 110) {
        digitalWrite(tuer,0);
     }
    }
  }
}

